package aoc2023

import CharGrid
import println
import readInput

/*
--- Day 13: Point of Incidence ---
With your help, the hot springs team locates an appropriate spring which launches you neatly and precisely up to the edge of Lava Island.
There's just one problem: you don't see any lava.
You do see a lot of ash and igneous rock; there are even what look like gray mountains scattered around. After a while, you make your way to a nearby cluster of mountains only to discover that the valley between them is completely full of large mirrors.  Most of the mirrors seem to be aligned in a consistent way; perhaps you should head in that direction?
As you move through the valley of mirrors, you find that several of them have fallen from the large metal frames keeping them in place. The mirrors are extremely flat and shiny, and many of the fallen mirrors have lodged into the ash at strange angles. Because the terrain is all one color, it's hard to tell where it's safe to walk or where you're about to run into a mirror.
You note down the patterns of ash (.) and rocks (#) that you see as you walk (your puzzle input); perhaps by carefully analyzing these patterns, you can figure out where the mirrors are!
For example:
#.##..##.
..#.##.#.
##......#
##......#
..#.##.#.
..##..##.
#.#.##.#.

#...##..#
#....#..#
..##..###
#####.##.
#####.##.
..##..###
#....#..#

To find the reflection in each pattern, you need to find a perfect reflection across either a horizontal line between two rows or across a vertical line between two columns.
In the first pattern, the reflection is across a vertical line between two columns; arrows on each of the two columns point at the line between the columns:
123456789
    ><
#.##..##.
..#.##.#.
##......#
##......#
..#.##.#.
..##..##.
#.#.##.#.
    ><
123456789

In this pattern, the line of reflection is the vertical line between columns 5 and 6. Because the vertical line is not perfectly in the middle of the pattern, part of the pattern (column 1) has nowhere to reflect onto and can be ignored; every other column has a reflected column within the pattern and must match exactly: column 2 matches column 9, column 3 matches 8, 4 matches 7, and 5 matches 6.
The second pattern reflects across a horizontal line instead:
1 #...##..# 1
2 #....#..# 2
3 ..##..### 3
4v#####.##.v4
5^#####.##.^5
6 ..##..### 6
7 #....#..# 7

This pattern reflects across the horizontal line between rows 4 and 5. Row 1 would reflect with a hypothetical row 8, but since that's not in the pattern, row 1 doesn't need to match anything. The remaining rows match: row 2 matches row 7, row 3 matches row 6, and row 4 matches row 5.
To summarize your pattern notes, add up the number of columns to the left of each vertical line of reflection; to that, also add 100 multiplied by the number of rows above each horizontal line of reflection. In the above example, the first pattern's vertical line has 5 columns to its left and the second pattern's horizontal line has 4 rows above it, a total of 405.
Find the line of reflection in each of the patterns in your notes. What number do you get after summarizing all of your notes?

*/
fun main() {

    val inlineTestInput = """
#.##..##.
..#.##.#.
##......#
##......#
..#.##.#.
..##..##.
#.#.##.#.

#...##..#
#....#..#
..##..###
#####.##.
#####.##.
..##..###
#....#..#
"""

    fun part1(input: List<String>): Int {
        val tmpList = ArrayList<String>()
        var result = 0
        for (i in input) {
            if (i.isNotBlank()) {
                tmpList.add(i)
            } else {
                val grid = CharGrid(tmpList)
                val ha = IntArray(grid.width)
                val haRev = IntArray(grid.width)
                val va = IntArray(grid.height)
                val vaRev = IntArray(grid.height)
                for (c in 0 until grid.width) {
                    for (r in 0 until grid.height) {
                        val revR = grid.height - 1 - r
                        ha[c] = ha[c] * 2 + (if (grid[c, r] == '#') 1 else 0)
                        haRev[c] = haRev[c] * 2 + if (grid[c, revR] == '#') 1 else 0
                    }
                }
                for (r in 0 until grid.height) {
                    for (c in 0 until grid.width) {
                        val revC = grid.width - 1 - c
                        va[r] = va[r] * 2 + if (grid[c, r] == '#') 1 else 0
                        vaRev[r] = vaRev[r] * 2 + if (grid[revC, r] == '#') 1 else 0
                    }
                }

                var href = 0
                for (sh in grid.height - 2 downTo 1) {
                    val mask = ((1 shl grid.height) - 1) shr sh
                    var found = false
                    for (c in 0 until grid.width) {
                        if ((ha[c] shr sh) and mask != haRev[c] and mask) {
                            found = false
                            break
                        }
                    }
                    if (found) {
                        href = sh
                    }
                }

                var vref = 0
                for (sh in grid.width - 2 downTo 1) {
                    val mask = ((1 shl grid.width) - 1) shr sh
                    var found = false
                    for (r in 0 until grid.height) {
                        if ((va[r] shr sh) and mask != vaRev[r] and mask) {
                            found = false
                            break
                        }
                    }
                    if (found) {
                        vref = sh
                    }
                }

                tmpList.clear()
            }
        }
        return result
    }

    fun part2(input: List<String>): Int {
        return 0
    }

    // test if implementation meets criteria from the description, like:
    val testInput = inlineTestInput.trim().reader().readLines()
    //val testInput = readInput("aoc2023/Day13_test")
    val testInputPart1Result = part1(testInput)
    println("Part 1 Test: $testInputPart1Result")
    val testInputPart2Result = part2(testInput)
    println("Part 2 Test: $testInputPart2Result")
    check(testInputPart1Result == 0)
    check(testInputPart2Result == 0)

    val input = readInput("aoc2023/Day13")
    part1(input).println()
    part2(input).println()
}
